
(* Written by Martin Kacer *)

Program SameGnome;
Const MAX_WIDTH	= 320;
	MAX_HEIGHT	= 160;
	EMPTY		= ' ';
	PTS_BASIC	= 2;
	PTS_BONUS	= 1000;
Var TaskCnt, TaskNum : Integer;
	Width, Height	 : Integer;
	X, Y			 : Integer;
	Field			 : Array [1..MAX_WIDTH, 1..MAX_HEIGHT] of Char;
	I, Moves		 : Integer;
	Score			 : Integer;
	Removed			 : Array [1..MAX_WIDTH] of Boolean;
	QueueX, QueueY	 : Array [1..(MAX_WIDTH*MAX_HEIGHT)] of Integer;
	QueueB, QueueE	 : Integer;

{ make one move, shift all pieces and return number of removed ones }
Function MakeMove (X, Y	: Integer) : Integer;
Var I, J, K	: Integer;
	Color	: Char;
	Procedure Enqueue (X, Y : Integer);
	Begin
		If (X >= 1) and (X <= Width) and (Y >= 1) and (Y <= Height) then
			If (Field[X,Y] = Color) and (Color <> EMPTY) then Begin
				Field[X,Y]:= EMPTY;
				QueueE:= QueueE + 1;
				QueueX[QueueE]:= X;
				QueueY[QueueE]:= Y;
				Removed[X]:= true;
			End;
	End; { Enqueue }
Begin
	{ remove area }
	For I:= 1 to Width do Removed[I]:= false;
	QueueB:= 0;
	QueueE:= 0;
	Color:= Field[X,Y];
	Enqueue (X, Y);
	While (QueueB < QueueE) do Begin
		QueueB:= QueueB + 1;
		X:= QueueX[QueueB];
		Y:= QueueY[QueueB];
		Enqueue (X+1,Y);
		Enqueue (X-1,Y);
		Enqueue (X,Y+1);
		Enqueue (X,Y-1);
	End;
	If (QueueE = 1) then Begin
		Field[X,Y]:= Color;
		Removed[X]:= false;
		QueueE:= 0;
	End;
	MakeMove:= QueueE;

	{ pieces falling down }
	For I:= 1 to Width do
		If (Removed [I]) then Begin
			K:= 1;
			For J:= 1 to Height do Begin
				Field[I,K]:= Field[I,J];
				If (Field[I,K] <> EMPTY) then K:= K + 1;
			End;
			If (K <= Height) then For J:= K to Height do
				Field[I,J]:= EMPTY;
		End;

	{ columns shifting left }
	For I:= 1 to Width do Removed[I]:= (Field[I,1] = EMPTY);
	K:= 1;
	For I:= 1 to Width do
		If not (Removed[I]) then
		Begin
			If (K < I) then
				For J:= 1 to Height do Field[K,J]:= Field[I,J];
			K:= K + 1;
		End;
	Width:= K-1;
End; { MakeMove }

Function CountPoints (Cnt : Integer) : Integer;
Begin
	CountPoints:= 0;
	if (Cnt > 2) then CountPoints:= (Cnt-PTS_BASIC) * (Cnt-PTS_BASIC);
End; { CountPoints }

Begin
	Readln (TaskCnt);
	For TaskNum:= 1 to TaskCnt do
	Begin
		ReadLn (Width, Height);
		For Y:= 1 to Height do Begin
			For X:= 1 to Width do
				Read (Field[X,Height-Y+1]);
			ReadLn;
		End;
		ReadLn (Moves);
		Score:= 0;
		For I:= 1 to Moves do
		Begin
			ReadLn (X, Y);
			If (Width > 0) then
				Score:= Score + CountPoints (MakeMove (X, Y));
			{If (Width > 0) then For Y:= 1 to Height do Begin
				For X:= 1 to Width do Write (Field[X,Height-Y+1]);
				WriteLn;
			End;}
		End;
		If (Width = 0) then Score:= Score + PTS_BONUS;
		Writeln ('Game over!');
		Writeln ('Score dosazene v teto hre je ', Score, ' bodu.');
		Writeln ('Byli bychom radi, kdybyste si zahrali jeste jednou.');
		Writeln ('Prejete si hrat znovu?');
		Writeln ('Prijemnou zabavu Vam preje firma ACMTENDO.');
	End;
End.
