
/* Problem "rozchod"
 *
 * Michal Sevcenko, 10/13/2000 */

#include <stdio.h>


#define bool int
#define true 1
#define false 0

#define MAX 100

int N, Center, Last;
int Length;
int Count;

bool VisitedCrossingsArray[MAX][MAX];


void TraversePath(int x, int y, int length)
{
	
	if (x == 0 || y == 0 || x == N || y == N)
	{
		if (length == 0) Count++;
		return;
	}
	if (length == 0) return;
	if (VisitedCrossingsArray[x][y]) return;
	
	VisitedCrossingsArray[x][y] = true;
	VisitedCrossingsArray[N-x][N-y] = true;

	TraversePath(x+1, y, length - 1);
	TraversePath(x-1, y, length - 1);
	TraversePath(x, y+1, length - 1);
	TraversePath(x, y-1, length - 1);

	VisitedCrossingsArray[x][y] = false;
	VisitedCrossingsArray[N-x][N-y] = false;
}

void DoIt()
{
	scanf("%i %i", &N, &Length);
	if ((N & 1) || (Length & 1) || Length < 3*N)
	{
		printf("Rozdeleni neni mozne.\n");
		return;
	}

	Length -= 2*N;
	if (Length == N)
	{
		printf("Existuje 1 ruznych moznosti.\n");
		return;
	}

	Length /= 2;
	Center = N/2;
	Count = 0;

	VisitedCrossingsArray[Center][Center] = true;
	TraversePath(Center-1, Center, Length-1);
	VisitedCrossingsArray[Center][Center] = false;
	if (Count/2 == 0)
		printf("Rozdeleni neni mozne.\n");
	else
		printf("Existuje %i ruznych moznosti.\n", Count / 2);
}

int main()
{
	int i, j, n;
	
	for (i=0; i<MAX; i++)
		for (j=0; j<MAX; j++)
			VisitedCrossingsArray[i][j] = 0;

	scanf("%i", &n);
	for (i=0; i<n; i++)
		DoIt();

	return 0;
}
